/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2023 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1alpha1 "tkestack.io/kstone/pkg/apis/kstone/v1alpha1"
)

// FakeEtcdInspections implements EtcdInspectionInterface
type FakeEtcdInspections struct {
	Fake *FakeKstoneV1alpha1
	ns   string
}

var etcdinspectionsResource = schema.GroupVersionResource{Group: "kstone.tkestack.io", Version: "v1alpha1", Resource: "etcdinspections"}

var etcdinspectionsKind = schema.GroupVersionKind{Group: "kstone.tkestack.io", Version: "v1alpha1", Kind: "EtcdInspection"}

// Get takes name of the etcdInspection, and returns the corresponding etcdInspection object, and an error if there is any.
func (c *FakeEtcdInspections) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.EtcdInspection, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(etcdinspectionsResource, c.ns, name), &v1alpha1.EtcdInspection{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EtcdInspection), err
}

// List takes label and field selectors, and returns the list of EtcdInspections that match those selectors.
func (c *FakeEtcdInspections) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.EtcdInspectionList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(etcdinspectionsResource, etcdinspectionsKind, c.ns, opts), &v1alpha1.EtcdInspectionList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.EtcdInspectionList{ListMeta: obj.(*v1alpha1.EtcdInspectionList).ListMeta}
	for _, item := range obj.(*v1alpha1.EtcdInspectionList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested etcdInspections.
func (c *FakeEtcdInspections) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(etcdinspectionsResource, c.ns, opts))

}

// Create takes the representation of a etcdInspection and creates it.  Returns the server's representation of the etcdInspection, and an error, if there is any.
func (c *FakeEtcdInspections) Create(ctx context.Context, etcdInspection *v1alpha1.EtcdInspection, opts v1.CreateOptions) (result *v1alpha1.EtcdInspection, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(etcdinspectionsResource, c.ns, etcdInspection), &v1alpha1.EtcdInspection{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EtcdInspection), err
}

// Update takes the representation of a etcdInspection and updates it. Returns the server's representation of the etcdInspection, and an error, if there is any.
func (c *FakeEtcdInspections) Update(ctx context.Context, etcdInspection *v1alpha1.EtcdInspection, opts v1.UpdateOptions) (result *v1alpha1.EtcdInspection, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(etcdinspectionsResource, c.ns, etcdInspection), &v1alpha1.EtcdInspection{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EtcdInspection), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeEtcdInspections) UpdateStatus(ctx context.Context, etcdInspection *v1alpha1.EtcdInspection, opts v1.UpdateOptions) (*v1alpha1.EtcdInspection, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(etcdinspectionsResource, "status", c.ns, etcdInspection), &v1alpha1.EtcdInspection{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EtcdInspection), err
}

// Delete takes name of the etcdInspection and deletes it. Returns an error if one occurs.
func (c *FakeEtcdInspections) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(etcdinspectionsResource, c.ns, name), &v1alpha1.EtcdInspection{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeEtcdInspections) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(etcdinspectionsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.EtcdInspectionList{})
	return err
}

// Patch applies the patch and returns the patched etcdInspection.
func (c *FakeEtcdInspections) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.EtcdInspection, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(etcdinspectionsResource, c.ns, name, pt, data, subresources...), &v1alpha1.EtcdInspection{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EtcdInspection), err
}
