/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2023 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
	kstonev1alpha1 "tkestack.io/kstone/pkg/apis/kstone/v1alpha1"
	versioned "tkestack.io/kstone/pkg/generated/clientset/versioned"
	internalinterfaces "tkestack.io/kstone/pkg/generated/informers/externalversions/internalinterfaces"
	v1alpha1 "tkestack.io/kstone/pkg/generated/listers/kstone/v1alpha1"
)

// EtcdInspectionInformer provides access to a shared informer and lister for
// EtcdInspections.
type EtcdInspectionInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.EtcdInspectionLister
}

type etcdInspectionInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewEtcdInspectionInformer constructs a new informer for EtcdInspection type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewEtcdInspectionInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredEtcdInspectionInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredEtcdInspectionInformer constructs a new informer for EtcdInspection type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredEtcdInspectionInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.KstoneV1alpha1().EtcdInspections(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.KstoneV1alpha1().EtcdInspections(namespace).Watch(context.TODO(), options)
			},
		},
		&kstonev1alpha1.EtcdInspection{},
		resyncPeriod,
		indexers,
	)
}

func (f *etcdInspectionInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredEtcdInspectionInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *etcdInspectionInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&kstonev1alpha1.EtcdInspection{}, f.defaultInformer)
}

func (f *etcdInspectionInformer) Lister() v1alpha1.EtcdInspectionLister {
	return v1alpha1.NewEtcdInspectionLister(f.Informer().GetIndexer())
}
